// created on 11/19/2005 at 1:26 AM by Aydemir Ulas Sahin

using System;
using GLib;
using Gtk;
using Mono.Unix;
using Sql;

namespace Banshee
{	
	public delegate void QueryTransactionHandler(object o, QueryTransactionEventArgs args);
	
	public class QueryTransactionEventArgs : EventArgs
    {
        public Statement query;
    }
    
	public class BrowserNoteBook : Notebook
	{
		private SqlBuilderUI query_builder;
		private ArtistAlbumBrowser browser;
		private VBox queryHolder = new VBox();
		
		public event QueryTransactionHandler QueryTransactionComplete;
		
		public BrowserNoteBook() : base()
		{
			BuildUI();
		}
		
		private void BuildUI()
		{
			browser = new ArtistAlbumBrowser();
			browser.HeightRequest = 150;
			browser.BrowserClicked += OnBrowserClicked;
			query_builder = new SqlBuilderUI(queryHolder);
			query_builder.SearchButtonClicked += OnSearchButtonClicked;
			
			AppendPage(browser, new Gtk.Label(Catalog.GetString("Browser")));
			AppendPage(queryHolder, new Gtk.Label(Catalog.GetString("Query")));
			
			ShowAll();
		}
		
		private void OnSearchButtonClicked(object o, EventArgs args)
        {
         	string query = query_builder.Query;    	
 			Statement query_statement = new Statement(query);
 			QueryLibrary(query_statement);	
        }
         
        private void OnBrowserClicked(object o, EventArgs args)
        {
         	string query = browser.Query;     	
 			Statement query_statement = new Statement(query);
 			QueryLibrary(query_statement);
        }
         
		public void QueryLibrary(Statement query)
        {
         	QueryTransactionHandler handler = QueryTransactionComplete;
            QueryTransactionEventArgs query_args = new QueryTransactionEventArgs();
     		query_args.query = query;
            if(handler != null)
            {
            	handler(this, query_args);
            }             	
        }
	}
}
